/* (C) Copyright 2012 Greensoft Pty Ltd, Australia (ACN 148 917 999). All rights reserved. */
package com.greensoft.objectdb.test.console;

import com.greensoft.objectdb.test.entity.Element;
import java.util.Collection;
import java.util.List;

/**
 *
 * @author darrenkelly
 */
public class Format {

    public void warn(String s) {
        System.out.println("WARNING: " + s);
    }

    public void out(String s) {
        System.out.println(s);
    }

    public void echo(String s) {
        //System.out.println(s);
        //log_info(s);
        out(s);
    }

    public void echo(String name, Object value) {
        //System.out.println(name+"("+value+")");
        //log_info(name+"("+value+")");
        out(name + "(" + value + ")");
    }

    public void viewCollection(String name, Collection collection) {
        echo(name + ":");

        if (collection == null) {
            warn("null collection");
        } else if (collection.isEmpty()) {
            warn("empty collection");
        } else {
            int n = 0;
            for (Object o : collection) {
                n++;
                if (o instanceof Element) {
                    //view((Element)o); //no expands
                    Element e = (Element) o;
                    out(" " + n + ": id(" + e.getId() + ") name(" + e.getName() + ")");
                }
            }
        }
    }

    public void viewElements(List<Element> elements) {
        for (Element e : elements) {
            out("\n*** " + e.getId() + " ***");
            view(e);
        }
    }
        //if (e instanceof LIst)

    public void view(Element e) {

        //selected attributes
        out("\n");
        echo("id", e.getId());
        echo("name", e.getName());
        echo("author", e.getAuthor());
        echo("dateCreated", e.getDateCreated());
        //echo("dateModified",e.getDateModified());
        echo("help", e.getHelp());
        echo("body", e.getBody());

        //selected relationships
        echo("project", e.getProject());
        echo("source", e.getSource());
        echo("owner", e.getOwner());
        viewCollection("ownedElements", e.getOwnedElements());
        viewCollection("constraints", e.getConstraints());
        viewCollection("tags", e.getTags());
        viewCollection("unmapped", e.getUnmapped());
        //echo("owner.name",e.getOwner() == null ? null : e.getOwner().getName());
    }

    //static private final
    static public final String $indent = "***";

    static public final String $indent2 = "******";

    public void outHeader(String $s) {
        //log_info($indent+" "+$s+" "+$indent);
        out($indent + " " + $s + " " + $indent);
    }

    public void outHeader2(String $s) {
        //log_info($indent2+" "+$s+" "+$indent2);    
        out("\n\n" + $indent2 + " " + $s + " " + $indent2 + "\n");
    }

}
