/* (C) Copyright 2012 Greensoft Pty Ltd, Australia (ACN 148 917 999). All rights reserved. */

package com.greensoft.objectdb.test.entity;

import java.util.ArrayList;
import java.util.List;
import javax.persistence.Entity;
import javax.persistence.ManyToMany;
import javax.persistence.Table;

/**
 *
 * @author darrenkelly
 */
@Entity
@Table(name="Constraints")
public class Constraint
extends Element
{

    public Constraint() {
    }

    public Constraint(
            Element owner,
            Project project,
            String name
            ) {
        super(owner, project, name);
    }

    private List<Element> constrainedElements = new ArrayList<Element>();
    @ManyToMany()
    /*
    @JoinTable(
        name="Constraint_constrained_Element",
        joinColumns=
            @JoinColumn(name="Constraint_ID", referencedColumnName="ID"),
            inverseJoinColumns=
            @JoinColumn(name="Element_ID", referencedColumnName="ID")
        )*/
    public List<Element> getConstrainedElements() {
        return constrainedElements;
    }
    public void setConstrainedElements(List<Element> constrainedElements) {
        this.constrainedElements = constrainedElements;
    }
    public boolean addConstrainedElement(Element e) {
        if (PERMIT_DUPLICATES || !getConstrainedElements().contains(e)) {
            return getConstrainedElements().add(e);
        }
        return false;
    }
    public boolean removeConstrainedElement(Element e) {
         return getConstrainedElements().remove(e);
    }
        
    private boolean asserted = false; 
    public boolean isAsserted() {
        return asserted;
    }
    public void setAsserted(boolean asserted) {
        this.asserted = asserted;
    }    
        
}
