/* (C) Copyright 2012 Greensoft Pty Ltd, Australia (ACN 148 917 999). All rights reserved. */
package com.greensoft.objectdb.test.entity;

import com.greensoft.objectdb.test.common.All_;
import java.net.MalformedURLException;
import java.net.URL;
import javax.persistence.*;

/** 
 * A persistent hyperlink with name (as title) and URL.
 *
 * @author darrenkelly
 */
@Entity
public class Link extends All_ {

    private static final long serialVersionUID = 1L;

    private Long id;

    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    
    @Transient 
    public URL getUrl() {
        try {
            return new URL($url);
        } catch (MalformedURLException ex) {
            log_error(ex);
            //Logger.getLogger(Link.class.getName()).log(Level.SEVERE, null, ex);
            return null;
        }        
    }
    
    private String $url;

    public String get$url() {
        return $url;
    }

    public void set$url(String $url) {
        this.$url = $url;
    }


    private String name;
    //@Size(max = 255)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Link() {
    }

    public Link(String name, String $url) //throws MalformedURLException
    {
        this.name = name;
        /*ObjectDB does not directly support persistent URL, but see Serialization parameter
        try {
            url = new URL($url);
        } catch (MalformedURLException ex) {
            log_error(ex);
            //Logger.getLogger(Link.class.getName()).log(Level.SEVERE, null, ex);
        }*/
        this.$url = $url;
    }

    public Link(String $url) //throws MalformedURLException
    {
        this(null, $url);
    }

    @Override
    public String toString() {
        return Link.class.getSimpleName() + " [" + getId() + "] name(" + getName() + "), URL(" + getUrl() + ")";
    }
    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Link)) {
            return false;
        }
        Link other = (Link) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }
    
}
