/* (C) Copyright 2012 Greensoft Pty Ltd, Australia (ACN 148 917 999). All rights reserved. */
package com.greensoft.objectdb.test.entity;

import java.io.Serializable;
import java.util.List;
import java.util.ArrayList;
import javax.persistence.Embeddable;
import javax.persistence.ElementCollection;

/**
 * 
 * @see Element
 *
 * @author darrenkelly
 */
@Embeddable
public class Permissions implements Serializable {

    public Permissions() {}

    private boolean mayReadAnonymous = true;
    public boolean isMayReadAnonymous() {
        return mayReadAnonymous;
    }
    public void setMayReadAnonymous(boolean mayReadAnonymous) {
        this.mayReadAnonymous = mayReadAnonymous;
    }

    private boolean mayEditAnonymous = false;
    public boolean isMayEditAnonymous() {
        return mayEditAnonymous;
    }
    public void setMayEditAnonymous(boolean mayEditAnonymous) {
        this.mayEditAnonymous = mayEditAnonymous;
    }

    private boolean mayHideAnonymous = false;
    public boolean isMayHideAnonymous() {
        return mayHideAnonymous;
    }
    public void setMayHideAnonymous(boolean mayHideAnonymous) {
        this.mayHideAnonymous = mayHideAnonymous;
    }

    private boolean mayKillAnonymous = false;
    public boolean isMayKillAnonymous() {
        return mayKillAnonymous;
    }
    public void setMayKillAnonymous(boolean mayKillAnonymous) {
        this.mayKillAnonymous = mayKillAnonymous;
    }

    private boolean mayReadAuthenticated = true;
    public boolean isMayReadAuthenticated() {
        return mayReadAuthenticated;
    }
    public void setMayReadAuthenticated(boolean mayReadAuthenticated) {
        this.mayReadAuthenticated = mayReadAuthenticated;
    }

    private boolean mayHideAuthenticated = true;
    public boolean isMayHideAuthenticated() {
        return mayHideAuthenticated;
    }
    public void setMayHideAuthenticated(boolean mayHideAuthenticated) {
        this.mayHideAuthenticated = mayHideAuthenticated;
    }

    private boolean mayEditAuthenticated = true;
    public boolean isMayEditAuthenticated() {
        return mayEditAuthenticated;
    }
    public void setMayEditAuthenticated(boolean mayEditAuthenticated) {
        this.mayEditAuthenticated = mayEditAuthenticated;
    }

    private boolean mayKillAuthenticated = false;
    public boolean isMayKillAuthenticated() {
        return mayKillAuthenticated;
    }
    public void setMayKillAuthenticated(boolean mayKillAuthenticated) {
        this.mayKillAuthenticated = mayKillAuthenticated;
    }

    private List<Role> mayReadRoles = new ArrayList<Role>(); //!
    @ElementCollection() 
    public List<Role> getMayReadRoles() {
        return mayReadRoles;
    }
    public void setMayReadRoles(List<Role> mayReadRoles) {
        this.mayReadRoles = mayReadRoles;
    }
    public boolean addMayReadRole(Role role) {
        if (getMayReadRoles().contains(role)) return false; //TODO warn
        return getMayReadRoles().add(role);
    }
    public boolean removeMayReadRole(Role role) {
        return getMayReadRoles().remove(role); //TODO warn
    }
    /** Whether the given role may read this object.
     */
    public boolean isMayReadRole(Role role) {
        return getMayReadRoles().contains(role);
    }

    private List<Role> mayHideRoles = new ArrayList<Role>(); //!
    @ElementCollection()
    public List<Role> getMayHideRoles() {
        return mayHideRoles;
    }
    public void setMayHideRoles(List<Role> mayHideRoles) {
        this.mayHideRoles = mayHideRoles;
    }
    public boolean addMayHideRole(Role role) {
        if (getMayHideRoles().contains(role)) return false; //TODO warn
        return getMayHideRoles().add(role);
    }
    public boolean removeMayHideRole(Role role) {
        return getMayHideRoles().remove(role); //TODO warn
    }
    public boolean isMayHideRole(Role role) {
        return getMayHideRoles().contains(role);
    }

    private List<Role> mayEditRoles = new ArrayList<Role>(); //!
    @ElementCollection()
    public List<Role> getMayEditRoles() {
        return mayEditRoles;
    }
    public void setMayEditRoles(List<Role> mayEditRoles) {
        this.mayEditRoles = mayEditRoles;
    }
    public boolean addMayEditRole(Role role) {
        if (getMayEditRoles().contains(role)) return false; //TODO warn
        return getMayEditRoles().add(role);
    }
    public boolean removeMayEditRole(Role role) {
        return getMayEditRoles().remove(role); //TODO warn
    }
    /** Whether the given role may edit this object.
     */
    public boolean isMayEditRole(Role role) {
        return getMayEditRoles().contains(role);
    }

    private List<Role> mayKillRoles = new ArrayList<Role>(); //!
    @ElementCollection()
    public List<Role> getMayKillRoles() {
        return mayKillRoles;
    }
    public void setMayKillRoles(List<Role> mayKillRoles) {
        this.mayKillRoles = mayKillRoles;
    }
    public boolean addMayKillRole(Role role) {
        if (getMayKillRoles().contains(role)) return false; //TODO warn
        return getMayKillRoles().add(role);
    }
    public boolean removeMayKillRole(Role role) {
        return getMayKillRoles().remove(role); //TODO warn
    }
    public boolean isMayKillRole(Role role) {
        return getMayKillRoles().contains(role);
    }

}
