/* (C) Copyright 2012 Greensoft Pty Ltd, Australia (ACN 148 917 999). All rights reserved. */
package com.greensoft.objectdb.test.entity;

import java.util.ArrayList;
import java.util.List;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.Transient;

/**
 *
 * @author darrenkelly
 */
@Entity
public class Tag extends Element {

    private static final long serialVersionUID = 1L;

    public Tag() {
        init();
    }

    public Tag(TagSet tagSetOwner, Project project, String name) {
        super(tagSetOwner, project, name);
        this.tagSet = tagSetOwner;
        init();
    }

    private void init() {
        //setDebug(true);
    }
    
    private TagSet tagSet;

    @ManyToOne(fetch=FetchType.LAZY)
    @JoinTable(name = "TagSet_Tag",
    joinColumns =
    @JoinColumn(name = "TagSet_ID", referencedColumnName = "ID"),
    inverseJoinColumns =
    @JoinColumn(name = "Tag_ID", referencedColumnName = "ID"))
    public TagSet getTagSet() {
        return tagSet;
    }

    public void setTagSet(TagSet tagSet) {
        //log_debug("Tag.setTagSet: "+tagSet);
        //logger.
        this.tagSet = tagSet;
    }
    private List<Element> taggedElements = new ArrayList<Element>();

    @ManyToMany()
    @JoinTable(name = "Tag_Element",
    joinColumns =
    @JoinColumn(name = "Tag_ID", referencedColumnName = "ID"),
    inverseJoinColumns =
    @JoinColumn(name = "Element_ID", referencedColumnName = "ID"))
    public List<Element> getTaggedElements() {
        return taggedElements;
    }

    public void setTaggedElements(List<Element> taggedElements) {
        this.taggedElements = taggedElements;
    }

    public boolean addTaggedElement(Element element) {
        if (getTaggedElements().contains(element)) {
            return false;
        }
        return getTaggedElements().add(element);
    }

    public boolean removeTaggedElement(Element element) {
        return getTaggedElements().remove(element);
    }

    @Transient
    public int getNumberTaggedElements() {
        return getTaggedElements().size();
    }
}
