package com.objectdb.test.adapted;

import java.util.ArrayList;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

/** http://www.objectdb.com/database/forum/9
 *
 * @author ObjectDB Forum 
 */
public class LazyTestAdapted {

    static private boolean DO_ACCESS_BEFORE_CLOSE = true;
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
               String path = "test.odb";
        EntityManagerFactory emf = Persistence.createEntityManagerFactory(path);
 
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        A_adapted a = new A_adapted();
        a.list = new ArrayList<B_adapted>();
        a.list.add(new B_adapted(1));
        a.list.add(new B_adapted(2));
        em.persist(a);
        em.getTransaction().commit();
        Long id = a.id;
        em.close();
 
        em = emf.createEntityManager();
        a = em.find(A_adapted.class, id);
        if (DO_ACCESS_BEFORE_CLOSE) System.out.println(a.list); //yields: [B_adapted(1), B_adapted(2)]
        em.close();
        if (!DO_ACCESS_BEFORE_CLOSE) System.out.println(a.list);// yields: []
 
        emf.close();
    }
}
