package com.objectdb.test.forum;

import java.util.*;
 
import javax.persistence.*;
 
/**
 *
 * @author ObjectDB forum: http://www.objectdb.com/database/forum/9
 */
public class LazyTest {
    
    public static void main(String[] args)  
    { 
        String path = "test.odb";
        EntityManagerFactory emf = Persistence.createEntityManagerFactory(path);
 
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        A a = new A();
        a.list = new ArrayList<B>();
        a.list.add(new B(1));
        a.list.add(new B(2));
        em.persist(a);
        em.getTransaction().commit();
        Long id = a.id;
        em.close();
 
        em = emf.createEntityManager();
        a = em.find(A.class, id);
        System.out.println(a.list);
        em.close();
 
        emf.close();
    }
 
    @Entity
    static class A {
        @Id @GeneratedValue Long id;
        @OneToMany(fetch=FetchType.LAZY, cascade=CascadeType.ALL) List<B> list;
    }
 
    @Entity
    static class B {
        @Id @GeneratedValue public Long id;
        int value;
        B(int value) { this.value = value; }
        @Override public String toString() { return "B(" + value + ")"; }
    }    
}
