package com.objectdb.test.support;
import javax.persistence.*;
/**
 * 
 * 
 * @author ObjectDB support (adapted by Darren Kelly)
 */
public class S230 {

    final static private boolean DO_USE_NODETACH = false;//Webel
    
    public static void main(String[] args) {
 
        //if (DO_USE_NODETACH) System.setProperty("objectdb.temp.no-detach", "true");//Included from http://www.objectdb.com/database/issue/48
        
        EntityManagerFactory emf =
            Persistence.createEntityManagerFactory(
                //"objectdb:$objectdb/test.odb;drop"//ERROR does not drop (and clashes with other test dbs)
                "objectdb:$objectdb/S230.tmp;drop"
                );
 
        EntityManager em = emf.createEntityManager();
        A a2 = new A("a2", null);
        A a1 = new A("a1", a2);
        em.getTransaction().begin();
        em.persist(a1);
        em.getTransaction().commit();
        em.close();
 
        em = emf.createEntityManager();
        a1 = em.find(A.class , 1);
        em.close();
 
        System.out.println(a1);
 
        emf.close();
    }
 
    @Entity
    public static class A {
        private String name;
        @ManyToOne(cascade=CascadeType.PERSIST, fetch=FetchType.LAZY)
        A a;
 
        A(String name, A a) {
            this.name = name;
            this.a = a;
        }
 
        @Override
        public String toString() {
            return name + "(" + a + ")";
        }
    }

}
